package com.eactive.eai.batch.job.jobItem.ssnet;

import java.io.ByteArrayOutputStream;
import java.util.HashMap;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobHandle.JobProcessData;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.batch.common.CommonKeys;
import com.eactive.eai.batch.common.LogUtil;
import com.eactive.eai.common.exception.ExceptionUtil;

public class RECV_SSNBT_0620 extends DefaultTelegram implements TelegramService
{

    /**
     * 생성자
     */
    public RECV_SSNBT_0620() {
        //결번확인요구
    }

    /**
     * 전문 해체하기
     */
    public boolean doExecute() {
        if (!super.doExecute()) return false;
        try {
            String _seq_no    = new String ((byte[]) al_Field.get(5));
            int recv_seq_no   = Integer.parseInt(_seq_no);
            int seq_no        = batchDoc.getBatchMsg().getBody().getSeqNum();

            if ( recv_seq_no < seq_no){
                // 0620으로 받은 BLOCK_NO가 EAIBatchMessage의 BLOCK_NO 보다 크거나
                // 0620으로 받은 SEQ_NO가 EAIBatchMessage의 SEQ_NO 보다 작으면 EEND처리 해야 함.
                this.setConditionTxt(TelegramKeys.ERROR);
                logger.debug("{}  received block_no is bigger than current block_no", logHeader);
                String[] msgArgs = new String[3];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = _seq_no;
                msgArgs[2] = ""+seq_no;
                String errCode = "BECEAIFJI024";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return false;
            }
            String procType = batchDoc.getBatchMsg().getHeader().getProcessType();
            if ( procType.equalsIgnoreCase(CommonKeys.PROCESS_REQUEST_SEND) ) {
            	if ( batchDoc.getBatchMsg().getHeader().getFileSize() <= batchDoc.getBatchMsg().getBody().getCurFileSize()){
            		this.setConditionTxt(TelegramKeys.EOF);
            		LogUtil.setLogFileEnd(batchDoc);
            	}
            	return true;
            }

            String uuid = this.batchDoc.getBatchMsg().getHeader().getUUID();
            JobProcessData job = JobProcessData.getInstance();
        	// 기 처리 완료된 시퀀스를 저장하여야 하는데 삼성네트웍스 프로토콜에서는 block 넘버가 의미 없으므로 이를 사용하도록 한다.
        	int lastSeq = batchDoc.getBatchMsg().getBody().getBlockNum();
 
            HashMap<String, Object> hm = job.getBatchStageData(uuid);
            @SuppressWarnings("unchecked")
            HashMap<Integer, byte[]> block_data = (HashMap<Integer, byte[]>)hm.get(JobProcessData.PROCDATA_BLOCKDATA);
            if (block_data == null ){
            	this.setConditionTxt(TelegramKeys.LOSS);
				batchDoc.getBatchMsg().getBody().setSeqNum(lastSeq+1);
            }

            for (int inx = lastSeq + 1; inx <= recv_seq_no; inx++) {
				if ( block_data.get( inx - 1 ) == null ){
	            	this.setConditionTxt(TelegramKeys.LOSS);
					batchDoc.getBatchMsg().getBody().setSeqNum(inx);
					break;
				}
			}


        } catch ( Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    /**
     * 전문 Validation
     */
    public boolean doValidation()
    {
        if (!super.doValidation()) return false;
        return true;
    }

    /**
     * int getCalculatedLength(int idx)
     * --------------------------------------------------------------------------------------
     * 전달된 인덱스 idx는 비정형 필드여야 한다. 즉 필드의 길이값이 FILE_NO_LENGTH("XX") 이어야 한다.
     * 해당 비정형 필드에 대해 실질적인 전문길이를 동적으로 계산해 낸다.
     * SEND : 송신 길이 계산
     * RECV : 수신 길이 계산
     */
    public int getCalculatedLength(int idx) {
        if (idx >= this.getFieldCount()) {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI011";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        if (this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
            try {
                String byte_size = new String ((byte[]) al_Field.get(0));
                logger.info("{} the sum of definite field length [" + byte_size + "]", logHeader);
                int preLen = 0;
                for (int inx = 1; inx < idx; inx++) {
                    byte[] aField = (byte[]) this.al_Field.get(inx);
                    preLen += aField.length;
                }
                return Integer.parseInt(byte_size) - preLen;
            } catch(Exception e) {
                String[] msgArgs = new String[1];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                String errCode = "BECEAIFJI005";
                String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                logger.error( e.getMessage(), e);
                return -1;
            }
        } else {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
    }

    public boolean doInformalField(int idx, byte[] data, int length)
    {
        return true;
    }

    
    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<5; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=5; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));
            batchDoc.getBatchMsg().getBody().setRecvFld05(new String ((byte[])this.al_Field.get(5)));
            return true;
        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(2);
    }

    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(3);
    }
}